%Dr. Lake-Ee Quek
%Australian Institute for Bioengineering and Nanotechnology (AIBN)
%C4flux Tool box: read C4 plant genome scale model from sbml file
%Reference:C4GEM - Genome-Scale Metabolic Model to study C4 plant
%metabolism
%********************************************************************
clear all;clc;
global rxnList
%Save these components in your local disc
[stoicMat, rxnTable,speciesList,speciesExtList,notesTable] = sbmlREAD('C4GEM_maize model.xml');
 save gemData stoicMat rxnTable speciesList speciesExtList notesTable
load gemData
[rxnOF OFcoeff]=textread('objectiveFunction.txt','%s%s%*s','delimiter','\t');
rxnOF(1)=[];OFcoeff(1)=[];
[rxnCon lbCon ubCon]=textread('reactionConstraints.txt','%s%s%s%*s','delimiter','\t');
rxnCon(1)=[];lbCon(1)=[];ubCon(1)=[];

rxnList = rxnTable(:,1);

bValue = 1000;
lb=[];ub=[];
for i = 1:size(rxnTable,1)
    if rxnTable{i,4}==1
        lb=[lb;-bValue];
        ub=[ub;bValue];
    else
        lb=[lb;0];
        ub=[ub;bValue];
    end
end

singletonRxns = findSR(stoicMat);
lb(singletonRxns)=0;ub(singletonRxns)=0;

for i = 1:size(rxnCon,1)
    if length(fR(rxnCon{i}))==0
        disp([rxnCon{i} ' not found, not used as constraints']);
        continue
    end
    if length(lbCon{i})>0
        lb(fR(rxnCon{i}))=str2num(lbCon{i});
    end
    if length(ubCon{i})>0
        ub(fR(rxnCon{i}))=str2num(ubCon{i});
    end
end


f = zeros(size(stoicMat,1),1);
for i = 1:size(rxnOF,1)
    if length(fR(rxnOF{i}))==0
        disp([rxnOF{i} ' not found, not used as OBJFXN']);
        continue
    end
    f(fR(rxnOF{i}))=str2num(OFcoeff{i});
end



beq = zeros(size(stoicMat,2),1);

[x fval exitflag] = linprog(f,[],[],stoicMat',beq,lb,ub);

res = sum(abs(stoicMat'*x));
if res <1e-3
    disp('flux is balanced')
else
    disp('error');
end